#define	ButtonSize	12
#define ButtonLeft	2
#define TitleGap	4

#define AddrMask	0x7FFFFFFF

#define inNone		0

#define Radius		8

#define OUTLINE_THICKNESS	3
#define OUTLINE_INSET		(OUTLINE_THICKNESS + 1)
#define OUTLINE_OUTSET		(-OUTLINE_INSET)
#define CURVE_ADJUSTMENT	6

enum {
	cTingeLight = 13,
	cTingeDark	= 14
};

enum {
	iFrameLight = 0,
	iHiliteLight = 0,
	iEmbossed,
	iBodyColor,
	iHiliteDark,
	iFrameDark,
	iFrameColor,
	iTextColor,
	iTingeLight,
	iTingeDark
};

typedef struct GrEG **GrEGHandle;
struct GrEG {
	short	markStyle[2];
	short	textStyle;
	short	buttonStyle;
	long	reserved;
};

typedef	struct {
			ControlHandle	theControl;
			long			msgParam;
			Boolean			inActive;
			Boolean			pushed;
			Boolean			pushButton;
			Boolean			radio;
			Boolean			useSysFont;
			Boolean			newFolder;
			GrEGHandle		prefs;
			Rect			theRect;
			RGBColor		theColors[9];
			Boolean			useTinges;
		}	GregInfo;

pascal long NewFolder ( short varCode, ControlHandle theControl, short msgCode, long msgParam );
// Entry point for the New Folder CDEF

pascal long Buttons ( short varCode, ControlHandle theControl, short msgCode, long msgParam );
// Entry point for the standard button CDEF

pascal long CDEF ( short varCode, ControlHandle theControl, short msgCode, long msgParam, Boolean newFolder );

pascal void DrawButton ( short, short, GDHandle, GregInfo * );
pascal void DrawIcon ( short, short, GDHandle, GregInfo * );

void DrawTitle	( GregInfo *, Boolean, Boolean, Boolean );

Boolean UseTinges ( RGBColor[] );
void GetPartColor ( CTabPtr theTable, RGBColor *theColor, short part );
void GetRGBColor ( CCTabHandle theTable, RGBColor *theColor, short backPart, short forePart, short shade);
void PrepareColors ( ControlHandle, RGBColor[] );
void DoDraw1 ( GregInfo *theInfo, CGrafPtr savePort, CGrafPtr myPort, Boolean onScreen );
void DoDraw ( GregInfo *theInfo );