#include <StandardFile.h>
#include <Connections.h>

#include "DSGlobals.h"
#include "DSUserProcs.h"
#include "LlamaTalk.h"

OSErr				gErr = noErr;
short				gSocket = 0;
LTGlobalsHdl		gLlamaTalkGlobals = nil;
Handle				gSocketConfigHdl = nil;
Handle				gSocketAddressHdl = nil;
Str255				gToolName = "\pApple Modem Tool";
LTSocketStatusRec	gSocketStatus;
Handle				gInDataHdl;
Handle				gOutDataHdl;



// *********
void MOpenComms()
{
	OSErr	error = noErr;
	Handle	socketConfigHdl = nil;
	Boolean connected;
	Boolean abort;
	short	state;

	
	gErr = LTOpenLlamaTalk(1, &gLlamaTalkGlobals);
	
	gSocketAddressHdl = GetNamedResource('LAMA', "\pMNP Address");
	gSocketConfigHdl = GetNamedResource('LAMA', "\pMNP Configuration");
	if (gSocketConfigHdl == nil)
       if (LTChoose(&gToolName, &gSocketConfigHdl))
       		;
	
	if (gSocketConfigHdl != nil)
		{
			gErr = LTNewSocket(gLlamaTalkGlobals, gToolName, gSocketConfigHdl, gSocketAddressHdl, 10, 10, &gSocket);
			if (gErr == noErr)
				LTListen(gLlamaTalkGlobals, gSocket);
			else
				DebugStr("\pError from LTNewSocket");
		}

	connected = FALSE;
	while ( ( !connected ) && ( !gDone ) ) {
		LTIdle(gLlamaTalkGlobals);
		state = LTGetSocketState(gLlamaTalkGlobals, gSocket);
		if ( (state == cLTStateError) || ( isPressed(0x2F) && isPressed(0x37) ) )
			gDone = TRUE;
		if (state == cLTStateReadWrite)
			connected = TRUE;
	}
}

void MCloseComms()
{
	short i;
	for (i=0;i<32;i++)
		LTIdle(gLlamaTalkGlobals);

	LTCloseLlamaTalk(gLlamaTalkGlobals);
}
