#include "About.h"
#include "Play.h"
#include "Main.h"
#include "DoMenu.h"

//#define TRUE		1
//#define FALSE		0
#define NIL			0

#define AppleMenu	1001
#define AppleAbout	1

#define FileMenu  	1002
#define FilePlay	1
#define FileStop	2
#define FileQuit  	4

#define EditMenu  	1003
#define EditUndo  	1
#define EditCut   	3
#define EditCopy  	4
#define EditPaste  	5
#define EditClear  	6
#define EditSelectAll 7

extern char 	PlayingFlag;

void DoMenu(char *doneFlag, short theMenu, short theItem, TEHandle *theInput)
{
GrafPtr   SavePort;
Str255    DAName;
short     DNA;
char      BoolHolder;

	switch (theMenu)
	{
		case AppleMenu:
			switch (theItem)
			{
				case AppleAbout:
					Open_About();
					break;
					
				default:    			/* Handle the DAs */
					GetPort(&SavePort);
					GetItem(GetMHandle(AppleMenu), theItem, DAName);/* Get the name of the DA selected */
					DNA = OpenDeskAcc(DAName);
					SetPort(SavePort);
					break;
			 
			}
			break;

		case FileMenu:
			switch (theItem)
			{
				case FilePlay:
					Init_Play();	/* start conversion */
					break;
				case FileStop:
					Cease_Play();
					break;	
				case FileQuit:
					*doneFlag = TRUE;/* Set exit the program flag */
					break;
				default:
					break;
			}
			break;
	
	
		case EditMenu:
			BoolHolder = SystemEdit(theItem - 1);/* Do DA editing */
			if (BoolHolder == FALSE)/* If not a DA then we get it */
			{
				switch (theItem) 
				{
					default:
						break;		 
			}
			}
			break;
		default:
			break;	 
}
HiliteMenu(0);
}

void AdjustMenus(void)
{
	WindowPtr 	window;
	MenuHandle	menu;
	long		offset;

	menu = GetMHandle(FileMenu);
	if (PlayingFlag)
	{
		DisableItem(menu,FilePlay);
		EnableItem(menu,FileStop);
	}
	else 
	{
		EnableItem(menu,FilePlay);
		DisableItem(menu,FileStop);
	};
	
	menu = GetMHandle(EditMenu);
	if (IsDAWindow(FrontWindow()))
	{
		EnableItem(menu,EditUndo);
		EnableItem(menu,EditCut);
		EnableItem(menu,EditCopy);
		EnableItem(menu,EditPaste);
		EnableItem(menu,EditClear);
		EnableItem(menu,EditSelectAll);
	}
	else 
	{
		DisableItem(menu,EditUndo);
		DisableItem(menu,EditCut);
		DisableItem(menu,EditCopy);
		DisableItem(menu,EditPaste);
		DisableItem(menu,EditClear);
		DisableItem(menu,EditSelectAll);
	}
}

Boolean IsDAWindow(WindowPtr window)
{
	short windowKind;
	
	if (window==NIL)
		return FALSE;
	else {
		windowKind = ((WindowPeek) window)->windowKind;
		return (windowKind < 0);
	}
}
