type 'wind' {
	integer;		/* xOffset */
	integer;		/* yOffset */
	integer;		/* maxCols */
	integer;		/* maxRows */
};

type 'icon' {
	integer;		/* actionType */
	longint;		/* itemID */
};

resource 'wind' (kMain, "Main") { 
	20,60, 3,2};
resource 'icon' (kFileManager, "FileManager") { 
	kCaution, kBadPath};
resource 'icon' (kDosPrompt, "DosPrompt") { 
	kError, kUAEError};
resource 'icon' (kControlPanel, "ControlPanel") { 
	kCaution, kDrWatson};
resource 'icon' (kClipboard, "Clipboard") { 
	kCaution, kNot3Error};
resource 'icon' (kPrintManager, "PrintManager") { 
	kError, kNoQueue};

resource 'wind' (kAccessories, "Accessories") {
	300,70, 2,3};
resource 'icon' (kNotepad, "Notepad") { 
	kError, kBadDir};
resource 'icon' (kCalendar, "Calendar") { 
	kCaution, kAssocError };
resource 'icon' (kPaintbrush, "Paintbrush") { 
	kYesNo, kChangedMsg};
resource 'icon' (kCalculator, "Calculator") { 
	kError, kUAEError};
resource 'icon' (kCardfile, "Cardfile") { 
	kError, kLostPath};
resource 'icon' (kClock, "Clock") { 
	kCaution, kAppClockErr};
resource 'icon' (kTerminal, "Terminal") { 
	kCaution, kNoComm };

resource 'wind' (kGames, "Games") {
	160,200, 2,2};
resource 'icon' (kMinesweeper, "Minesweeper") { 
	kGameAction, 0};
resource 'icon' (kSolitare, "Solitare") { 
	kCaution, kAssocError};
resource 'icon' (kReversi, "Reversi") { 
	kError, kNoMem};

resource 'STR#' (rTitleStr, "Title") {
	{
		"Invalid Path",
		"Invalid Path",
		"Invalid Path",
		"Application Execution Error",
		"Unrecoverable Application Error",
		"Application Execution Error",
		"Application Execution Error",
		"Cannot Run Program",
		"Terminal - Error",
		"Dr. Watson",
		"Paintbrush",
		"Error",
		"Windows Help",
		"Exit Windows",
		"Luddite User",
		"Windows Resource Error",
	}
};

resource 'STR#' (rTextStr, "Text") {
	{
		"\nThe path C:\\BIN\\ROOTGDI.PIF is invalid.",
		"\nThe working directory is invalid.",
		"Cannot find file (or one of its components).\n\n"
			"Make sure the path and filenames are correct\n"
			"and that all required libraries are available.",
		"Application Error.\n\n"
			"CLOCK caused a General Protection Fault in\n"
			"module CLOCK.EXE at 0001:0D8E.",
		"Unrecoverable Application Error.\n\n"
			"Faults of this type have been renamed\n"
			"for Windows 3.1.",
		"No application is associated with this file.\n\n"
			"Choose associate from the File menu to\n"
			"create an association.",
		"Insufficient memory to run this application.\n\n"
			"Quit one or more Windows applications and\n"
			"then try again.",
		"The application you are about to run was \n"
			"designed to run with Windows 2.0\n\n"
			"Obtain an updated version for Windows 3.1",
		"The selected COM port is either not supported\n"
			"or is being used by another device.\n\n"
			"Select another port.",
		"Your 'Dr. Watson' log file 'c:\\drwatson.log'\n"
			" is getting quite large.",
		"(untitled)\n"
			"The image has changed\n\n"
			"Do you want to save current changes?",
		"The print queue does not exist. The print queue\n"
			"may have been removed by an administer.",
		"Missing or Misplaced Help Item.\n\n"
			"Why not just makeup something yourself?",
		"\nThis will end your windows session.",
		"Creating new program groups is only supported\n"
			"under System 7.0 or DOS 5.0\n\n"
			"        Get real...",
		"Too many program groups\n\n"
			"Stop jerking me around...",
	}
};

