/* START OF FILE: File_Resource_Utilities.h */


/*=**************************************************************************=*/
/* [---BEGIN---] FILE HEADER COMMENTS */
/**
 ** SCREEN VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** PRINTER VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** =======================================================================
 ** Written by James Merkle
 ** File_Resource_Utilities.h - Header file for File_Resource_Utilities.c
 ** (C) Copyright 1995 James Merkle
 ** =======================================================================
 **
 **
 ** ============
 ** Revision History
 ** ============
 **
 **  Refer to "File_Resource_Utilities.c"
 **						
 **
 ** ====================
 ** OTHER INFORMATION
 ** ====================
 ** 
 **
 **/
/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/



/*=**************************************************************************=*/
#ifndef _H_File_Resource_Utilities

#define _H_File_Resource_Utilities
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #include AREA */


/* [----END----] #include AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #define AREA */


/* [----END----] #define AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */


/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */

extern Safe_Boolean	Save_Pict_Resource_As_New_File(FSSpec	*desired_File, PicHandle	picture_Handle);

extern Safe_Boolean Add_Resource_Handle(Handle resource_To_Create_Hdl
											, ResType resource_Type
											, INTEGER_16 resource_ID
											, Str255 resource_Comment);

extern Safe_Boolean	Get_File_Specification_For_Save(FSSpec		*file_Specification
															, CARDINAL_8	*assumed_File_Name
															, CARDINAL_8	*message_String
															, Safe_Boolean *user_Abort);

extern Safe_Boolean	Save_Pict_As_New_Pict_File(FSSpec	*desired_File
													, PicHandle	picture_Handle);

/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] extern DECLARATIONS */


/* [----END----] extern DECLARATIONS */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */


/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#endif
/*=**************************************************************************=*/
/* END OF FILE: File_Resource_Utilities.h */