/* START OF FILE: Number_Utilities.h */


/* [---BEGIN---] FILE HEADER COMMENTS */
/**
 ** SCREEN VIEW = [Adobe Syntax Black-10, Tabs = 6]
 ** PRINTER VIEW = [Adobe Syntax Black-10, Tabs = 6]
 ** =======================================================================
 ** Skeleton v1.0, Skeleton is an application program that does nothing.
 ** Written by Jim Wolff, and Jim Merkle
 ** Number_Utilities.h - Header for Number_Utilities.c
 ** NS_Shell, The Shell From Hell
 ** =======================================================================
 **
 **
 ** =============
 ** Revision History
 ** =============
 ** SEE NS_Shell_Main.c for revision history and version number.
 **
 ** ====================
 ** OTHER INFORMATION
 ** ====================
 ** 
 **
 **/
/* [----END----] FILE HEADER COMMENTS */


/*=**************************************************************************=*/
#ifndef _H_Number_Utilities

#define _H_Number_Utilities
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] FILE INCLUDE AREA */

#include "Shell_Globals.h"

/* [----END----] FILE INCLUDE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] DEFINE AREA */
#pragma mark DEFINE_AREA

#define Maximum(aa, bb)		((aa) > (bb)) ? aa : bb

/* [----END----] DEFINE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */

/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */
							
extern void Manually_Initialize_Seeds (INTEGER_32 value_1, INTEGER_32 value_2);

extern void Auto_Initialize_Seeds(void);

extern CARDINAL_32 Fetch_Random_Number_RAW(void);

extern SPEED_DIGITS_REAL Fetch_Random_Number_Float(void);

/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] EXTERN DECLARATION AREA */


/* [----END----] EXTERN DECLARATION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */

/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#endif
/*=**************************************************************************=*/
/* END OF FILE: Number_Utilities.h */

