/* START OF FILE: Remote_Control_Full.h */


/*=**************************************************************************=*/
/* [---BEGIN---] FILE HEADER COMMENTS */
/**
 ** SCREEN VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** PRINTER VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** =======================================================================
 ** Written by James Merkle
 ** Remote_Control_Full.h - Header for Remote_Control_Full.c
 ** (C) Copyright 1994 James Merkle
 ** =======================================================================
 **
 **
 ** ============
 ** Revision History
 ** ============
 **
 **  Refer to "Remote_Control_Full.c"
 **						
 **
 ** ====================
 ** OTHER INFORMATION
 ** ====================
 ** 
 **
 **/
/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/



/*=**************************************************************************=*/
#ifndef _H_Remote_Control_Full

#define _H_Remote_Control_Full
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #include AREA */

#include "Shell_Globals.h"

/* [----END----] #include AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #define AREA */

#define k_SIMPLE_ANSWER_AE			0x0000
#define k_SELECT_NEXT_ITEM_AE			0x0001
#define k_SELECT_PREVIOUS_ITEM_AE	0x0002
#define k_SELECT_ITEM_AE					0x0003
#define k_SELECT_CALLER_ITEM_AE		0x0004

#define k_ACKNOWLEDGE_SIMPLE_ANSWER_AE				0x1000
#define k_ACKNOWLEDGE_SELECT_NEXT_ITEM_AE			0x1001
#define k_ACKNOWLEDGE_SELECT_PREVIOUS_ITEM_AE	0x1002
#define k_ACKNOWLEDGE_SELECT__ITEM_AE				0x1003


/* [----END----] #define AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */


/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */

extern Safe_Boolean Initialize_Remote_Control_Full(void);

extern Safe_Boolean Destroy_Remote_Control_Full(void);

extern Safe_Boolean Setup_Remote_Control_Full(void);

extern Safe_Boolean Enable_Remote_Menu(void);

extern Safe_Boolean Disable_Remote_Menu(void);

extern Safe_Boolean Send_Remote_Message(CARDINAL_32	command, Ptr parameters);

extern Safe_Boolean Proccess_Response_Queue_If_Needed(void);

/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] extern DECLARATIONS */


/* [----END----] extern DECLARATIONS */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */


/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#endif
/*=**************************************************************************=*/

/* END OF FILE: Remote_Control_Full.h */
