/*
	File: PIProperties.h

	Copyright 1994-95 by Adobe Systems, Inc.  All rights reserved.

	This file describes the key for the get properties callback.
*/

/* Get the number of channels.  Returns the number of channels in the simple
   property field. */
   
#define propNumberOfChannels  'nuch'

/* Returns a handle containing the characters for the name of the channel. */

#define propChannelName		  'nmch'

/* Returns the image mode using the plugInMode constants.  (Simple) */

#define propImageMode		  'mode'

/* Returns the number of channels including the work path. (Simple) */

#define propNumberOfPaths	  'nupa'

/* Returns the name of the indexed path (zero-based). (Complex) */

#define propPathName          'nmpa'

/* Returns the contents of the indexed path (zero-based). (Complex) */

#define propPathContents      'path'

/* The index of the work path.  -1 if no work path. (Simple) */

#define propWorkPathIndex     'wkpa'

/* The index of the clipping path.  -1 if none. (Simple) */

#define propClippingPathIndex 'clpa'

/* The index of the target path.  -1 if none. (Simple) */

#define propTargetPathIndex   'tgpa'




