//========================================================================================
//
// Photoshop.h - Adobe Photoshop include file, handles load/dump
//
// Part of the Adobe Photoshop 3.0 Plug-In Developer's Toolkit.
//
// Header file written 10/20/94 by Dave Wise
//
// Copyright  1994-95, Adobe Systems Incorporated, all rights reserved worldwide.
//
// Version	1.00	10/20/94	Original version
//
//========================================================================================

#if defined(MAKEDUMP) || defined(__PPCC__) || defined(THINK_C) || defined(mwc)

	#include "MacStd.h"
	
	#if defined(__PPCC__)
		#pragma options align=mac68k
	#endif
	
	#include "DialogUtilities.h"
	#include "PIAbout.h"
	#include "PIAcquire.h"
	#include "PIExport.h"
	#include "PIFilter.h"
	#include "PIFormat.h"
	#include "PIGeneral.h"
	#include "PIProperties.h"
	#include "PITypes.h"
	#include "PIUtilities.h"

	#if defined(MAKEDUMP)
		#pragma dump ":h:Photoshop.d"
	#endif
#else

	#pragma load ":h:Photoshop.d"

#endif
