#ifndef __SOM__
#include <som.xh>
#endif

#ifndef __SOMOBJ__
#include <somobj.xh>
#endif

#ifndef __FRAGRSRC__
#include <FragRsrc.h>
#endif

#ifndef _ODMEMORY_
#include "ODMemory.h"
#endif

#ifdef applec
#pragma segment Woof
#endif

#include "Debug.h"
#include "WoofItem.xh"
#include "WoofService.xh"
#include "WoofLibraryInit.h"


// Information for this library's resource fork
CFragResFileRef gFragResFileRef_WoofLibrary;



SOMEXTERN void SOMLINK WoofLibrarySOMInit (long, long, string );
extern "C" OSErr WoofLibraryCFMInit (InitBlockPtr initBlkPtr);
extern "C" void __sinit(void);



SOMEXTERN void SOMLINK WoofLibrarySOMInit (long majorVersion, 
                                       long minorVersion, 
                                       string className)
	{
	AppleCyberdog_WoofItemNewClass(majorVersion, minorVersion);
	AppleCyberdog_WoofServiceNewClass(majorVersion, minorVersion);
	}



OSErr WoofLibraryCFMInit (InitBlockPtr initBlkPtr)
	{
	__sinit();
	

	#if __CFM68K__
	OSErr err= LinkupQDGlobals();
	if( err ) return err;
	#endif

	return InitCFragResources(initBlkPtr, &gFragResFileRef_WoofLibrary);
	}
	
	
	
CFragResFileRef WoofLibraryGetResFileData()
	{
	return gFragResFileRef_WoofLibrary;
	}

