#ifndef WoofItem_h
#define WoofItem_h

#include "RealCyberItem.h"

class TRealWoofItem : public TRealCyberItem
{
	public:
									TRealWoofItem();
			virtual					~TRealWoofItem();
			
			virtual	void			SetUpFromURL(Environment* ev, char* url, StringPtr defaultName = nil);
					
			virtual void			ExternalizeContent(Environment* ev, ODStorageUnit* su);
			
			virtual void			StreamToStorageUnit(Environment* ev, ODStorageUnit* su);
			virtual void			StreamFromStorageUnit(Environment* ev, ODStorageUnit* su);
	
			virtual TRealCyberItem*	Clone(Environment* ev);
			
			virtual CICompareType	Compare(Environment* ev, TRealCyberItem* compare);

			virtual	URL				GetURL(Environment* ev);
			
			virtual Handle			GetIconSuite(Environment* ev);
			
			virtual	CyberStream*	CreateCyberStream(Environment* ev);

			virtual ODTypeToken		GetContentKind(Environment *ev, ODSession* session);
			
	private:
					char*			fURL;
};

#endif	// WoofItem_h
