
/*
	Beware, this stuff will probably not be compatible with anything in future
	MacOS versions.  Or at least that is what DTS has said since 1990.

*/
#include "LayerMgr.h"

LayerPtr FindLayerForSignature(OSType processSig)
{
	LayerPtr	aLayer;
	
	aLayer = GetFirstLayer();
	while (aLayer) {
		LayerInfoPtr	layerInfo = GetLayerInfo(aLayer);
		if (layerInfo->signature == processSig)
			return(aLayer);
		else
			aLayer = GetNextLayer(aLayer);
	}
	
	return(NULL);
}

WindowPtr GetFrontWindowForSignature(OSType processSig)
{
	LayerPtr aLayer;
	
	aLayer = FindLayerForSignature(processSig);
	if (aLayer)
		return(GetFirstLayerWindow(aLayer));
	else
		return(NULL);
}
