/*
	GEBalls.h
	
	Balls for GEQDHack
	
	6/10/95
	
	Al Evans
	
*/

#include "GraphElements.h"

#define		rRedBall	401
#define		rBlueBall	403

#define		redBallPlane	400
#define		blueBallPlane	300

#define		firstRBID		'RBL\0'
#define		firstBBID		'BBL\0'

#define		rBallSnd		400

#define		numberOfBalls	3

#ifdef __cplusplus
extern "C" {
#endif

Boolean InitBallGraphics(GEWorldPtr world);

// Ball's autochange proc

pascal void DoBallRandom(GEWorldPtr world, GrafElPtr obj);

// Ball's collision proc
pascal void DoBallCollide(GEWorldPtr world, GrafElPtr ball, 
					GEDirection dir, CollisionPhase phase, GrafElPtr objHit);

#ifdef __cplusplus
}
#endif
