// HackMenu.h
// Copyright  1994-95 by Apple Computer, Inc. All rights reserved.

#ifndef __HACKMENU__
#define __HACKMENU__

#ifndef __UTEAROFFMENUVIEW__
#include "UTearOffMenuView.h"
#endif

#ifndef __UVIEW__
#include "UView.h"
#endif

//--------------------------------------------------------------------------------------------------
// CLASS THackMenu
//--------------------------------------------------------------------------------------------------
class THackMenu : public TTearOffMenuView
{
	MA_DECLARE_CLASS;

  public:
	THackMenu();		// Constructor
	void IHackMenu(ResNumber menuID, ResNumber windowID);
};

//--------------------------------------------------------------------------------------------------
// CLASS THackView
//--------------------------------------------------------------------------------------------------
class THackView : public TView
{
	MA_DECLARE_CLASS;

  public:
	THackView();		// Constructor
	virtual void DoEvent(EventNumber eventNumber,
						 TEventHandler* source,
						 TEvent* event); // override
};

//----------------------------------------------------------------------------------------

#endif // __HACKMENU__
