// Copyright  1994-95 by Apple Computer, Inc. All rights reserved.
// MDrawShapes.cp

#ifndef __UDRAWSHAPES__
#include "UDrawShapes.h"
#endif

// MacApp

#ifndef __UDIALOG__
#include <UDialog.h>
#endif					 

#ifndef __UERRORMGR__
#include <UErrorMgr.h>
#endif					 

#ifndef __UFLOATWINDOW__
#include "UFloatWindow.h"
#endif

#ifndef __UMACAPPGLOBALS__
#include <UMacAppGlobals.h>
#endif

#ifndef __UMACAPPUTILITIES__
#include <UMacAppUtilities.h>
#endif

#ifndef __UMENUVIEW__
#include <UMenuView.h>
#endif

#ifndef __UPRINTING__
#include <UPrinting.h>
#endif


//----------------------------------------------------------------------------------------
// main: 
//----------------------------------------------------------------------------------------
#pragma push
#pragma processor 68000
#pragma segment Main

void main()
{
	InitUMacApp(2);					// Initialize MacApp with 2 calls to MoreMasters.

	InitUDialog();
	InitUMenuView();
	InitUFloatWindow();
	InitUPrinting();

	TShapeApplication* aShapeApplication = new TShapeApplication;
	aShapeApplication->IShapeApplication();
	aShapeApplication->Run();

} // main

#pragma pop
