/* ===================================

File: conversion.h
Function: Header for conversion routines
History: 11/12/89 Original by bc.

================================= */

#include <stdio.h>

extern  void  Init_Play(void);

/* Convert one line of the input file into one line of the output file */
extern void Play1(void);

/* Shut up */
extern void Cease_Play(void);

/* If a serious error happens (file system, etc) */
/* This one will abort processing, delete output file, 
   and pop up the Lose box. It's assumed that the ParamText is set. */
extern void Explode(void);

extern char *Rest(char *s);

extern char *FirstEntry(char *s);

short ChangeStates(short startstate);

Boolean timetodrop(void);

void DropBall(void);

void Shower(void);
