/* START OF FILE: OS_Extra_Utilities.h */

/*=********************************************************************=*/
/* [---BEGIN---] FILE HEADER COMMENTS */
/**
 ** SCREEN VIEW = Adobe Syntax Black-10, Tabs=6 chars
 ** PRINTER VIEW = Adobe Syntax Black -10, Tabs=0.30 inch
 ** ========================================================================
 ** Written by James Merkle
 ** [OS_Extra_Utilities.h] - More Miscellaneous utilities related to operating system functions
 ** current version (C) Copyright 1992 James Merkle
 ** ========================================================================
 **
 **
 ** ============
 ** Revision History
 ** ============
 ** See OS_Extra_Utilities.c for revision history and version number.
 **
 ** ===============
 ** OTHER INFORMATION
 ** ===============
 **			
 **
 **/
/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#ifndef _H_OS_Extra_Utilities

#define _H_OS_Extra_Utilities
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] FILE INCLUDE AREA */

#include "Shell_Globals.h"

/* [----END----] FILE INCLUDE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] DEFINE AREA */
#pragma mark DEFINE_AREA


/* [----END----] DEFINE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */
	

/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */
#pragma mark PROTOTYPE_AREA

extern Safe_Boolean	Post_Gestalt_Breadcrumbs_If_Needed ( OSType Application_ID
									, Str63				stored_File_Name
									, INTEGER_16		stored_Volume_Reference_Num
									, INTEGER_32		stored_Directory_ID	
									, Safe_Boolean 	*already_Present );

extern pascal void Debug_With_TMON(void);

extern void Reset_Parameter_Ram_Settings_For_Serial_Ports(void);


/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] EXTERN DECLARATION AREA */


/* [----END----] EXTERN DECLARATION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */

/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#endif
/*=**************************************************************************=*/
/* END OF FILE: OS_Extra_Utilities.h */
