/* START OF FILE: MOD_Utilities.h */


/*=**************************************************************************=*/
/* [---BEGIN---] FILE HEADER COMMENTS */
/**
 ** SCREEN VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** PRINTER VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** =======================================================================
 ** Written by James Merkle
 ** MOD_Utilities.h - Header file for MOD_Utilities.c
 ** (C) Copyright 1995 James Merkle
 ** =======================================================================
 **
 **
 ** ============
 ** Revision History
 ** ============
 **
 **  Refer to "MOD_Utilities.c"
 **						
 **
 ** ====================
 ** OTHER INFORMATION
 ** ====================
 ** 
 **
 **/
/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/



/*=**************************************************************************=*/
#ifndef _H_MOD_Utilities

#define _H_MOD_Utilities
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #include AREA */

#include "Shell_Globals.h"
#include "MOD_Utilities_rDriver.h"

/* [----END----] #include AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #define AREA */


/* [----END----] #define AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */



/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */

extern Safe_Boolean Load_MOD_Utilities_Driver(void);

extern Safe_Boolean Destroy_MOD_Utilities(void);

extern Safe_Boolean Destroy_MOD_Driver(void);

extern Safe_Boolean Initialize_MOD_Utilities(void);

extern Safe_Boolean Start_MOD_Playback(void);

extern Safe_Boolean Stop_MOD_Playback(void);

extern void Play_A_User_Selected_Music_File(void);

extern Safe_Boolean Stop_Playing_MOD_Resource(MADPartition	*new_Music_Partition
													,Handle			*resource_Hdl);

extern Safe_Boolean Start_Playing_MOD_Resource(INTEGER_16 resource_ID
												, MADPartition	*new_Music_Partition
												, Handle			*resource_Hdl);


/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] extern DECLARATIONS */


/* [----END----] extern DECLARATIONS */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */


/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#endif
/*=**************************************************************************=*/
/* END OF FILE: MOD_Utilities.h */