/* START OF FILE: Dreaming_Audio_Record.h */


/*=**************************************************************************=*/
/* [---BEGIN---] FILE HEADER COMMENTS */
/**
 ** SCREEN VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** PRINTER VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** =======================================================================
 ** Written by James Merkle
 ** Dreaming_Audio_Record.h - Header file for xxx.c
 ** (C) Copyright 1995 James Merkle
 ** =======================================================================
 **
 **
 ** ============
 ** Revision History
 ** ============
 **
 **  Refer to "Dreaming_Audio_Record.c"
 **						
 **
 ** ====================
 ** OTHER INFORMATION
 ** ====================
 ** 
 **
 **/
/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/



/*=**************************************************************************=*/
#ifndef _H_Dreaming_Audio_Record

#define _H_Dreaming_Audio_Record
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #include AREA */

#include "Dreaming_Audio.h"
#include "Sound_Record.h"

/* [----END----] #include AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #define AREA */


/* [----END----] #define AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */


/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */

extern Safe_Boolean Destroy_Dreaming_Audio_Record(void);

extern Safe_Boolean Initialize_Dreaming_Audio_Record(void);

extern Safe_Boolean Inform_Program_Of_Recording_Completion(Record_Sound_To_File_Hdl *audio_Tapping_Hdl
																, Memory_Allocation *audio_Tapping_Initialized);

extern Safe_Boolean Start_Recording_To_AIFF_File(Record_Sound_To_File_Hdl *audio_Tapping_Hdl
												, Memory_Allocation *audio_Tapping_Initialized
												, Safe_Boolean create_File_Without_User_Inquiry
												, CARDINAL_32 number_Of_Channels
												, CARDINAL_32 sample_Rate
												, CARDINAL_32 sample_Size
												, CARDINAL_32 compression_Type);

extern Safe_Boolean Stop_Recording_To_Any_Open_Audio_Files(void);

extern Safe_Boolean Stop_Recording_To_Voice_Audio_File(Voice_Hdl	voice);

extern Safe_Boolean Start_Recording_From_First_Talking_Item_In_Current_Scene(Safe_Boolean create_File_Without_User_Inquiry);

/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] extern DECLARATIONS */


/* [----END----] extern DECLARATIONS */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */


/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#endif
/*=**************************************************************************=*/
/* END OF FILE: Dreaming_Audio_Record.h */