/* START OF FILE: Dreaming_File_Loading.h */


/*=**************************************************************************=*/
/* [---BEGIN---] FILE HEADER COMMENTS */
/**
 ** SCREEN VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** PRINTER VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** =======================================================================
 ** Written by James Merkle
 ** Dreaming_File_Loading.h - Header to support Poor Man's Video Phone
 ** (C) Copyright 1993 James Merkle
 ** =======================================================================
 **
 **
 ** ============
 ** Revision History
 ** ============
 **
 **  Refer to "Dreaming_File_Loading.c"
 **						
 **
 ** ====================
 ** OTHER INFORMATION
 ** ====================
 ** 
 **
 **/
/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/



/*=**************************************************************************=*/
#ifndef _H_Dreaming_File_Loading

#define _H_Dreaming_File_Loading
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #include AREA */

#include <PictUtil.h>
#include "Shell_Globals.h"


/* [----END----] #include AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #define AREA */

#define	k_PUPPET_FILE_TYPE											'MJSt'
#define	k_PUPPET_PICS_FILE_TYPE									'PICS'
#define	k_PUPPET_MAIN_RESOURCE_TYPE						'Pupp'
#define	k_BASE_PUPPET_RESOURCE_ID		129

/* [----END----] #define AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */


/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */

extern Safe_Boolean	Save_Puppet_Sequence(CARDINAL_32 index_Used
															, Safe_Boolean *user_Abort);

extern Safe_Boolean	Load_Puppet_Sequence(CARDINAL_32 index_Used
															, INTEGER_16	puppet_Offset
															, FSSpec		*file_Specification);

extern Safe_Boolean	Specify_Puppet_To_Load(FSSpec		*file_Specification
															, Safe_Boolean *user_Abort);

extern Safe_Boolean	Export_Puppet_Sequence(CARDINAL_32 index_Used
															, Safe_Boolean *user_Abort);


/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] extern DECLARATIONS */


/* [----END----] extern DECLARATIONS */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */


/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#endif
/*=**************************************************************************=*/
/* END OF FILE: Dreaming_File_Loading.h */