/* START OF FILE: Dreaming_Popup_Dialogs.h */


/*=**************************************************************************=*/
/* [---BEGIN---] FILE HEADER COMMENTS */
/**
 ** SCREEN VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** PRINTER VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** =======================================================================
 ** Written by James Merkle
 ** Dreaming_Popup_Dialogs.h - Header file for Dreaming_Popup_Dialogs.c
 ** (C) Copyright 1995 James Merkle
 ** =======================================================================
 **
 **
 ** ============
 ** Revision History
 ** ============
 **
 **  Refer to "Dreaming_Popup_Dialogs.c"
 **						
 **
 ** ====================
 ** OTHER INFORMATION
 ** ====================
 ** 
 **
 **/
/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/



/*=**************************************************************************=*/
#ifndef _H_Dreaming_Popup_Dialogs

#define _H_Dreaming_Popup_Dialogs
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #include AREA */

#include "Shell_Globals.h"

/* [----END----] #include AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #define AREA */

#define k_ALL_SELECTIONS						0

#define k_PICT_SELECTION						1

#define k_SCENE_SELECTION					2	
#define k_PROP_SELECTION					3
#define k_PUPPET_SELECTION				4
#define k_ITEM_IN_SCENE_SELECTION	5
#define k_BACKDROP_SELECTION			6
#define k_SPIN_OBJECT_SELECTION		7

#define k_SCENE_FILE_SELECTION				8	
#define k_PUPPET_FILE_SELECTION			9	
#define k_PROP_FILE_SELECTION				10	
#define k_BACKDROP_FILE_SELECTION			11	
#define k_SPIN_OBJECT_FILE_SELECTION		12	

#define k_SLIDE_SELECTION									13	
#define k_REMOTE_SLIDE_SELECTION					14
#define k_WINDOW_SIZE_SELECTION					15

#define k_TRANSITION_SELECTION										16
#define k_FIRST_TRANSITION_SELECTION							17
#define k_ANIMATED_PUPPET_IN_SCENE_SELECTION			18

#define k_AUDIO_OBJECT_FILE_SELECTION							19


#define k_WINDOW_SIZE_DEFAULT_STRING "\pDefault Window Size (resource)"
#define k_WINDOW_SIZE_640_390_STRING "\p640 * 390"
#define k_WINDOW_SIZE_638_455_STRING "\p638 * 455"
#define k_WINDOW_SIZE_640_480_STRING "\p640 * 480"
#define k_WINDOW_SIZE_960_720_STRING "\p960 * 720"
#define k_WINDOW_SIZE_FILLSCREEN_STRING "\pCover Screen (not menubar)"

#define k_WINDOW_SIZE_DIRECT_SETTING		0

#define k_WINDOW_SIZE_DEFAULT		1
#define k_WINDOW_SIZE_640_390		2
#define k_WINDOW_SIZE_638_455		3
#define k_WINDOW_SIZE_640_480		4
#define k_WINDOW_SIZE_960_720		5
#define k_WINDOW_SIZE_FILLSCREEN	6

/* [----END----] #define AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */


/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */

extern Safe_Boolean Get_Dream_Popup_Menu_Choice(CARDINAL_16	type_of_List
																, CARDINAL_32	*resulting_Index
																, Safe_Boolean 	*valid_Result);

/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] extern DECLARATIONS */


/* [----END----] extern DECLARATIONS */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */


/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#endif
/*=**************************************************************************=*/
/* END OF FILE: Dreaming_Popup_Dialogs.h */