/* START OF FILE: Graphics_Demos_Support.h */


/*=**************************************************************************=*/
/* [---BEGIN---] FILE HEADER COMMENTS */
/**
 ** SCREEN VIEW = [Adobe Syntax Black-10, Tabs = 6]
 ** PRINTER VIEW = [Adobe Syntax Black-10, Tabs = 6]
 ** =======================================================================
 ** Written by Jim Merkle
 ** Graphics_Demos_Support.h - Header for Animation_Utilities.
 ** 1990 by Jim Merkle.
 ** =======================================================================
 **
 **
 ** ============
 ** Revision History
 ** ============
 ** SEE xxxx.c for revision history and version number.
 **
 ** =================
 ** OTHER INFORMATION
 ** =================
 ** 
 **
 **/
/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#ifndef _H_Graphics_Demos_Support

#define _H_Graphics_Demos_Support
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] FILE INCLUDE AREA */


/* [----END----] FILE INCLUDE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] DEFINE AREA */
 
/* [----END----] DEFINE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */

/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */

extern	void Get_Screen_Low_Level_Info (void);
extern Boolean Generate_Primary_Display(void);
extern Boolean Generate_Test_Rect_Display(void);
extern Boolean Generate_Test_Circle_Display(void);
extern Boolean Generate_Test_Filled_Circle_Display(void);
extern Boolean Generate_Test_Elipses_Display(void);
extern Boolean Generate_Test_Filled_Elipses_Display(void);
extern Boolean Generate_Test_Line_Display(void);
extern Boolean Generate_Test_Three_D_Display(void);

extern Boolean Generate_Test_Line_Pattern_Speed_Display(void);
extern Boolean Generate_Demo_Clipped_Outline_Display(void); 

/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] EXTERN DECLARATION AREA */


/* [----END----] EXTERN DECLARATION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */

/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#endif
/*=**************************************************************************=*/
/* END OF FILE: Graphics_Demos_Support.h */
