/* START OF FILE: Smart_Copy_Ticked_Pixels.h */


/*=**************************************************************************=*/
/* [---BEGIN---] FILE HEADER COMMENTS */
/**
 ** SCREEN VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** PRINTER VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** =======================================================================
 ** Written by James Merkle
 ** Smart_Copy_Ticked_Pixels.c - Routines to support Poor Man's Video Phone
 ** (C) Copyright 1994 James Merkle
 ** =======================================================================
 **
 **
 ** ============
 ** Revision History
 ** ============
 **
 **  Refer to "Smart_Copy_Ticked_Pixels.c"
 **						
 **
 ** ====================
 ** OTHER INFORMATION
 ** ====================
 ** 
 **
 **/
/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/



/*=**************************************************************************=*/
#ifndef _H_Smart_Copy_Ticked_Pixels

#define _H_Smart_Copy_Ticked_Pixels
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #include AREA */

#include "Shell_Globals.h"

/* [----END----] #include AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #define AREA */


/* [----END----] #define AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */


/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */

typedef struct {
	Safe_Boolean			initialized;
	CARDINAL_32		current_Structure_Size;
	Scan_Bounds_Rec	scan_Info;
} Smart_Copy_Rec, *Smart_Copy_Ptr, **Smart_Copy_Hdl;

/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] extern DECLARATIONS */

extern Safe_Boolean Add_Span_Entry_To_Smart_Copy_List(Smart_Copy_Rec *smart_Copy_Info_Ptr
															, CARDINAL_32 vertical_Line_Affected
															, CARDINAL_32 horizontal_Address_Start
															, CARDINAL_32 horizontal_Address_Stop);
															
extern Safe_Boolean Add_Picture_Spans_To_Smart_Copy_List(Smart_Copy_Rec *smart_Copy_Info_Ptr
																,  Scan_Bounds_Ptr source_Bounds_Info
																, CARDINAL_32	horizontal_Offset
																, CARDINAL_32	vertical_Offset);

extern Safe_Boolean Delete_New_Smart_Copy_List(Smart_Copy_Hdl *smart_Copy_Info_Hdl);

extern Safe_Boolean Clear_New_Smart_Copy_List(Smart_Copy_Rec *smart_Copy_Info_Ptr);

extern Safe_Boolean Build_New_Smart_Copy_List(CARDINAL_32 total_Height, Smart_Copy_Hdl *smart_Copy_Info_Hdl);

/* [----END----] extern DECLARATIONS */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */


/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#endif
/*=**************************************************************************=*/
/* END OF FILE: Smart_Copy_Ticked_Pixels.h */