///--------------------------------------------------------------------------------------
//	BlitPixie.h
//
//	Created:	Thursday, September 24, 1992 at 11:48 PM
//	By:		Tony Myles
//
//	Pieced together by Tony Myles and Ben Sharpe
//	Special thanks to Brigham Stevens and Sean Callahan
//
//	Portions Copyright:  1991-93 Tony Myles, All rights reserved worldwide.
//	Portions Copyright:  1993 Ben Sharpe, All rights reserved worldwide.
///--------------------------------------------------------------------------------------


#ifndef __BLITPIXIE__
#define __BLITPIXIE__

#ifndef __QUICKDRAW__
#include <QuickDraw.h>
#endif

#include "Sprite_World_Common.h"

#ifndef __FRAME__
#include "Sprite_World_Frame.h"
#endif


#ifdef __cplusplus
extern "C" {
#endif

	// non-mask copy
void BlitPixie(PixMapPtr sourceImage, PixMapPtr destImage, 
	Rect *sourceRect, Rect *destRect, Rect *boundsRect);

	// masked copy
void BlitPixieMask(PixMapPtr maskPixMapP, PixMapPtr sourceImage, PixMapPtr destImage, 
	Rect *sourceRect, Rect *destRect, Rect *boundsRect);

SW_PASCAL void BlitPixieEraseProc(FramePtr srcFrameP, FramePtr dstFrameP, Rect *srcRect, Rect *dstRect);
SW_PASCAL void BlitPixieDrawProc(FramePtr srcFrameP, FramePtr dstFrameP, Rect *srcRect, Rect *dstRect, RgnHandle maskRgn);
SW_PASCAL void BlitPixieMaskDrawProc(FramePtr srcFrameP, FramePtr dstFrameP, Rect *srcRect, Rect *dstRect);

#ifdef __cplusplus
};
#endif
#endif /* __BLITPIXIE__ */
