/* [Core_Universal.c] START OF FILE */

/* [---BEGIN---] FILE HEADER COMMENTS */

/**
 ** SCREEN VIEW = Adobe Syntax Black-10, Tabs=6
 ** PRINTER VIEW = Adobe Syntax Black -10, Tabs=0.30 inch
 ** ========================================================================
 ** Core_Universal
 ** Written by Jim Merkle
 ** [Core_Specific.c] - supporting routines for Poor Man's Video Phone that invoke Mac toolbox
 ** (C) Copyright 1991 by Jim Merkle
 ** All rights reserved, except those wishing to "copy" moderate sections of code or files may do so, so long as
 ** such code is never used directly either in animation-related tools or multimedia tools that are  
 ** used in live performance or live broadcast or recorded mass market broadcast or film. Desktop usage not restricted.
 ** Conventional desktop game or entertainment not restricted.
 ** ========================================================================
 **
 **
 ** =============
 ** Revision History
 ** =============
 **
 **  1991.11.25		(James Merkle)
 **						Initial coding started, routines transferred from 'Non_Specific_Support_Routines.h' and modified
 **
 **
 **
 **
 ** =================
 ** OTHER INFORMATION
 ** =================
 **
 **
 **
 **/

/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/



/*=**************************************************************************=*/

/* [---BEGIN---] FILE INCLUDE AREA */

/*#include "Automatic_Dialogs.h" */
#include "Error_Utilities.h"
#include "Memory_Utilities.h"
#include "Program_Globals.h"
#include "Shell_Assembly.h"
#include "Shell_Dialogs.h"
#include "Shell_Globals.h"
#include "String_Utilities.h"

#include "Core_Specific.h" /* Specific_Support_Routines */

#include "Core_Universal.h" /* Non_Specific_Support_Routines */


/* [----END----] FILE INCLUDE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] DEFINE AREA */


/* [----END----] DEFINE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */



/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPES-------------------------- */
#pragma mark PROTOTYPE_AREA

/*------------ LOCAL PROTOTYPES -------------------*/


/* [----END----] PROTOTYPES-------------------------- */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] GLOBAL DEFINITION AREA */


/* [----END----] GLOBAL DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */

static CARDINAL_8				*unit_Name = "\pCore_Universal";

/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Perform_OK_Dialog_Hook(Str255 message)
{
	Perform_OK_Dialog(message);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void C_Display_Error_Message(CARDINAL_8	*unit_Name
						, CARDINAL_8	*code_Name
						, CARDINAL_8	*description_String
						, CARDINAL_8	*note_String)
{
	Display_Serious_Error_Message(unit_Name, code_Name, description_String, note_String);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* END OF FILE: Core_Universal.c */
